import { ChangeDetectorRef, ElementRef, OnInit, QueryList, TemplateRef, ViewContainerRef, InjectionToken } from '@angular/core';
import { MatFormField, MatFormFieldControl } from '@angular/material/form-field';
import { Observable } from 'rxjs';
import { ErrorMessages } from './error-meassages';
import * as i0 from "@angular/core";
export declare const NGX_MAT_ERROR_DEFAULT_OPTIONS: InjectionToken<ErrorMessages>;
export interface ErrorOutletContext<T> {
    $implicit?: T;
}
export declare class NgxMatErrorDef implements OnInit {
    template: TemplateRef<any>;
    ngxMatErrorDefFor: string;
    constructor(template: TemplateRef<any>);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatErrorDef, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxMatErrorDef, "[ngxMatErrorDef]", never, { "ngxMatErrorDefFor": "ngxMatErrorDefFor"; }, {}, never, never, false>;
}
export declare class NgxMatErrorOutlet {
    readonly viewContainer: ViewContainerRef;
    readonly elementRef: ElementRef;
    constructor(viewContainer: ViewContainerRef, elementRef: ElementRef);
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatErrorOutlet, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxMatErrorOutlet, "[ngxMatErrorOutlet]", never, {}, {}, never, never, false>;
}
export declare class NgxMatErrors<T> implements OnInit {
    private readonly cdRef;
    private readonly matFormField;
    private readonly messages;
    private readonly messageKeys;
    constructor(cdRef: ChangeDetectorRef, messages: ErrorMessages | null, matFormField: MatFormField);
    readonly errorOutlet: NgxMatErrorOutlet;
    readonly customErrorMessages: QueryList<NgxMatErrorDef>;
    readonly error$: Observable<string>;
    control?: MatFormFieldControl<any> | '' | null;
    ngOnInit(): void;
    private initError;
    private _populateErrorOutlet;
    private _getCustomErrorMessage;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatErrors<any>, [null, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxMatErrors<any>, "ngx-mat-errors, [ngx-mat-errors]", never, { "control": "ngx-mat-errors"; }, {}, ["customErrorMessages"], never, false>;
}
